/*!
 * SAP UI development toolkit for HTML5 (SAPUI5/OpenUI5)
 * (c) Copyright 2009-2015 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/core/RenderManager','./Template','sap/ui/thirdparty/handlebars'],function(q,R,T,h){"use strict";var H=T.extend("sap.ui.core.tmpl.HandlebarsTemplate",{constructor:function(i,s){T.apply(this,arguments);}});T.registerType("text/x-handlebars-template","sap.ui.core.tmpl.HandlebarsTemplate");function d(o){for(var k in o){o[k]=o[k].replace("&gt;",">").replace("&lt;","<").replace("&quot;","\"").replace("&amp;","&");}}function a(p,P){return(/^(\/|\w+>\/)/.test(p)?"":(P||""))+p;}H.RENDER_HELPERS=(function(){var e=Handlebars.helpers["each"],w=Handlebars.helpers["with"],I=Handlebars.helpers["if"],u=Handlebars.helpers["unless"],r=new R();r.renderControl=function(c){this.writeControlData(c);this.writeClasses(c);this.writeStyles(c);};var o={"each":function(c,b){b=b||c;if(!b.hash.path){return e.apply(this,arguments);}else{d(b.hash);var f=b.data.renderManager,g=b.data.rootControl,p=b.data.path,P=b.data.parentControl,s=a(b.hash.path,p),i=g.bindList(s),j=[],k;if(b.data){k=Handlebars.createFrame(b.data);}if(i){for(var K in i){if(k){k.renderManager=f;k.rootControl=g;k.path=s+"/"+K+"/";k.parentControl=P;}j.push(b.fn({},{data:k}));}}if(!P){return new Handlebars.SafeString(j.join(""));}}},"with":function(c,b){b=b||c;if(!b.hash.path){return w.apply(this,arguments);}},"if":function(c,b){b=b||c;if(!b.hash.path){return I.apply(this,arguments);}else{d(b.hash);var f=b.data.rootControl,p=b.data.path,P=a(b.hash.path,p);if(P){var v=f.bindProp(P);if(v){return b.fn(this);}else{return b.inverse(this);}}}},"unless":function(c,b){b=b||c;if(!b.hash.path){return u.apply(this,arguments);}else{d(b.hash);var f=b.data.rootControl,p=b.data.path,P=a(b.hash.path,p);if(P){var v=f.bindProp(P);if(!v){return b.fn(this);}else{return b.inverse(this);}}}},"text":function(c,b){b=b||c;d(b.hash);var f=b.data.rootControl,p=b.data.path,P=a(b.hash.path,p);if(P){var v=f.bindProp(P);return v&&new Handlebars.SafeString(q.sap.encodeHTML(v));}else{throw new Error("The expression \"text\" requires the option \"path\"!");}},"element":function(c,b){b=b||c;d(b.hash);var f=b.data.renderManager,g=b.data.rootControl,E=g.createDOMElement(b.hash,b.data.path),p=b.data.parentElement;if(b.fn){b.fn({},{data:{renderManager:f,rootControl:g,parentElement:E}});}if(p){p.addElement(E);return;}return new Handlebars.SafeString(f.getHTML(E));},"control":function(c,b){b=b||c;d(b.hash);var f=b.data.renderManager,C=b.data.control;if(C){return new Handlebars.SafeString(f.getHTML(C));}var g=b.data.rootControl,p=b.data.path,P=b.data.children,t=b.hash["sap-ui-type"],m=q.sap.getObject(t).getMetadata(),D=b.hash["sap-ui-default-aggregation"]||m.getDefaultAggregationName(),v=b.data.view;var j={};if(b.fn){b.fn({},{data:{rootControl:g,path:p,children:j,defaultAggregation:D,view:v}});}var s=q.extend({},b.hash);for(var k in s){if(j[k]){delete s[k];}}var n=g.createControl(s,b.data.path,!!P,v);if(!q.isEmptyObject(j)){s=b.hash;var A=m.getAllAggregations();for(var x in j){var y=j[x];for(var i=0,l=y.length;i<l;i++){var z=y[i],B=A[x],M=B&&B.multiple;if(typeof s[x]==="string"){var E=sap.ui.base.ManagedObject.bindingParser(s[x],v&&v.getController());E.template=z;n.bindAggregation(x,E);}else{if(M){n.addAggregation(x,z);}else{n.setAggregation(x,z);}}}}}if(P){var x=b.hash["sap-ui-aggregation"]||b.data.defaultAggregation;P[x]=P[x]||[];P[x].push(n);return;}return new Handlebars.SafeString(f.getHTML(n));},"property":function(c,b){b=b||c;d(b.hash);var f=b.data.rootControl,m=f.getMetadata(),p=b.hash.name,g=m.getProperty(p)._sGetter;return f[g]();},"aggregation":function(c,b){b=b||c;d(b.hash);if(b.data.children){var A=b.hash.name;if(b.fn){var D=q.extend({},b.data,{defaultAggregation:A});b.fn({},{data:D});}}else{var f=b.data.renderManager,g=b.data.rootControl,m=g.getMetadata(),A=b.hash.name,G=m.getAggregation(A)._sGetter,j=[];var C=g[G]();if(C){for(var i=0,l=C.length;i<l;i++){if(b.fn){j.push(b.fn({},{data:{renderManager:f,rootControl:g,control:C[i]}}));}else{j.push(f.getHTML(C[i]));}}}return new Handlebars.SafeString(j.join(""));}},"event":function(c,b){b=b||c;},"controlData":function(c,b){b=b||c;var f=b.data.rootControl;return new Handlebars.SafeString(r.getHTML(f));}};return o;}());H.prototype.createMetadata=function(){var t=this.getContent(),f=this._fnTemplate=this._fnTemplate||Handlebars.compile(t);var m={},j=sap.ui.core.tmpl.TemplateControl.getMetadata().getAllSettings(),p=sap.ui.core.tmpl.TemplateControl.getMetadata().getAllPrivateAggregations();var o={"property":function(c,b){b=b||c;d(b.hash);var n=b.hash.name;if(n&&n!=="id"&&!j[n]){m.properties=m.properties||{};m.properties[n]=q.extend({},{type:"string"},b.hash);}else{throw new Error("The property name \""+n+"\" is reserved.");}},"aggregation":function(c,b){b=b||c;d(b.hash);var n=b.hash.name;if(n&&!j[n]&&!p[n]){b.hash.multiple=b.hash.multiple=="true";m.aggregations=m.aggregations||{};m.aggregations[n]=q.extend({},b.hash);}else{throw new Error("The aggregation name \""+n+"\" is reserved.");}},"event":function(c,b){b=b||c;},"controlData":function(c,b){b=b||c;m._hasControlData=true;}};q.each(["each","if","unless","with"],function(i,v){o[v]=function(){};});f({},{helpers:o});return m;};H.prototype.createRenderer=function(v){var t=this.getContent(),f=this._fnTemplate=this._fnTemplate||Handlebars.compile(t);var r=function(b,c){var s=f(c.getContext()||{},{data:{renderManager:b,rootControl:c,view:v},helpers:H.RENDER_HELPERS});b.write(s);};return r;};return H;},true);
