/*!
 * SAP UI development toolkit for HTML5 (SAPUI5/OpenUI5)
 * (c) Copyright 2009-2015 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/layout/ResponsiveFlowLayout','sap/ui/layout/ResponsiveFlowLayoutData','./FormLayout','sap/ui/layout/library'],function(q,R,a,F,l){"use strict";var b=F.extend("sap.ui.layout.form.ResponsiveLayout",{metadata:{library:"sap.ui.layout"}});sap.ui.core.Control.extend("sap.ui.layout.form.ResponsiveLayoutPanel",{metadata:{aggregations:{"content":{type:"sap.ui.layout.ResponsiveFlowLayout",multiple:false}},associations:{"container":{type:"sap.ui.layout.form.FormContainer",multiple:false},"layout":{type:"sap.ui.layout.form.ResponsiveLayout",multiple:false}}},getLayoutData:function(){var c=sap.ui.getCore().byId(this.getContainer());var L=sap.ui.getCore().byId(this.getLayout());var o;if(L&&c){o=L.getLayoutDataForElement(c,"sap.ui.layout.ResponsiveFlowLayoutData");}return o;},getCustomData:function(){var c=sap.ui.getCore().byId(this.getContainer());if(c){return c.getCustomData();}},refreshExpanded:function(){var c=sap.ui.getCore().byId(this.getContainer());if(c){if(c.getExpanded()){this.$().removeClass("sapUiRLContainerColl");}else{this.$().addClass("sapUiRLContainerColl");}}},renderer:function(r,p){var c=sap.ui.getCore().byId(p.getContainer());var L=sap.ui.getCore().byId(p.getLayout());var C=p.getContent();if(!c||!L){return;}var e=c.getExpandable();var t=c.getTooltip_AsString();r.write("<div");r.writeControlData(p);r.addClass("sapUiRLContainer");if(e&&!c.getExpanded()){r.addClass("sapUiRLContainerColl");}if(t){r.writeAttributeEscaped('title',t);}r.writeClasses();L.getRenderer().writeAccessibilityStateContainer(r,c);r.write(">");if(c.getTitle()){L.getRenderer().renderTitle(r,c.getTitle(),c._oExpandButton,e,false,c.getId());}if(C){r.write("<div");r.addClass("sapUiRLContainerCont");r.writeClasses();r.write(">");r.renderControl(C);r.write("</div>");}r.write("</div>");}});(function(){b.prototype.init=function(){this.mContainers={};this._defaultLayoutData=new a({margin:false});};b.prototype.exit=function(){var t=this;for(var C in this.mContainers){k(t,C);}if(this._mainRFLayout){this._mainRFLayout.destroy();delete this._mainRFLayout;}this._defaultLayoutData.destroy();delete this._defaultLayoutData;};b.prototype.onBeforeRendering=function(E){var i=this.getParent();if(!i||!(i instanceof sap.ui.layout.form.Form)){return;}i._bNoInvalidate=true;var t=this;_(t,i);n(t,i);i._bNoInvalidate=false;};b.prototype.contentOnAfterRendering=function(i,C){F.prototype.contentOnAfterRendering.apply(this,arguments);if(C.getWidth&&(!C.getWidth()||C.getWidth()=="auto")&&C.getMetadata().getName()!="sap.ui.commons.Image"){C.$().css("width","100%");}};b.prototype.toggleContainerExpanded=function(C){var s=C.getId();if(this.mContainers[s]&&this.mContainers[s][0]){var p=this.mContainers[s][0];p.refreshExpanded();}};b.prototype.onLayoutDataChange=function(E){var s=E.srcControl;var C;var i;var p;if(s instanceof sap.ui.layout.form.FormContainer){if(this._mainRFLayout){this._mainRFLayout.onLayoutDataChange(E);}}else if(s instanceof sap.ui.layout.form.FormElement){i=s.getParent().getId();if(this.mContainers[i]&&this.mContainers[i][1]){this.mContainers[i][1].onLayoutDataChange(E);}}else{var P=s.getParent();if(P instanceof sap.ui.layout.form.FormElement){C=P.getParent();i=C.getId();p=P.getId();if(this.mContainers[i]&&this.mContainers[i][2]&&this.mContainers[i][2][p]){this.mContainers[i][2][p][0].onLayoutDataChange(E);}}}};b.prototype.onsapup=function(E){this.onsapleft(E);};b.prototype.onsapdown=function(E){this.onsapright(E);};function _(L,p){var C=p.getFormContainers();var r;var s;var t=C.length;var v=0;var P;var u;var i=0;for(i=0;i<t;i++){r=C[i];r._checkProperties();if(r.getVisible()){v++;s=r.getId();P=undefined;u=undefined;if(L.mContainers[s]&&L.mContainers[s][1]){u=L.mContainers[s][1];}else{u=f(L,r,undefined);}var T=r.getTitle();if(T||r.getExpandable()){if(L.mContainers[s]&&L.mContainers[s][0]){P=L.mContainers[s][0];}else{P=c(L,r,u);g(u,true);}}else{if(L.mContainers[s]&&L.mContainers[s][0]){d(L.mContainers[s][0]);g(u,false);}}var w=e(L,r,u);L.mContainers[s]=[P,u,w];}}var O=o(L.mContainers);if(v<O){for(s in L.mContainers){var x=false;for(i=0;i<t;i++){r=C[i];if(s==r.getId()&&r.getVisible()){x=true;break;}}if(!x){k(L,s);}}}}function c(L,C,r){var s=C.getId();var p=new sap.ui.layout.form.ResponsiveLayoutPanel(s+"--Panel",{container:C,layout:L,content:r});return p;}function d(p){p.setContent("");p.setLayout("");p.setContainer("");p.destroy();}function e(L,C,p){var s=C.getId();var E=C.getFormElements();var r=E.length;var v=0;var t={};if(L.mContainers[s]&&L.mContainers[s][2]){t=L.mContainers[s][2];}var u;var w;var x=-1;var y;var z;var i=0;for(i=0;i<r;i++){y=E[i];if(y.getVisible()){z=y.getId();m(L,C,y,t,p,i);if(t[z]){u=t[z][0];x=p.indexOfContent(u);}else{u=f(L,C,y);u.addStyleClass("sapUiRLElement");if(y.getLabel()){u.addStyleClass("sapUiRLElementWithLabel");}t[z]=[u,undefined];x++;p.insertContent(u,x);}var A=y.getFields();if(y.getLabel()&&A.length>1){if(t[z][1]){w=t[z][1];}else{w=f(L,C,y,true);w.addStyleClass("sapUiRLElementFields");t[z][1]=w;}h(L,w,A);}else{if(t[z][1]){w=t[z][1];j(w);t[z][1]=undefined;}}v++;}}var O=o(t);if(v<O){for(z in t){var B=false;for(i=0;i<r;i++){y=E[i];if(z==y.getId()&&y.getVisible()){B=true;break;}}if(!B){if(t[z][1]){w=t[z][1];j(w);}u=t[z][0];p.removeContent(u);j(u);delete t[z];}}}return t;}function f(L,C,E,i){var I;if(E&&!i){I=E.getId()+"--RFLayout";}else if(E&&i){I=E.getId()+"--content--RFLayout";}else if(C){I=C.getId()+"--RFLayout";}else{return false;}var r=new R(I);r.__myParentLayout=L;r.__myParentContainerId=C.getId();if(E){r.__myParentElementId=E.getId();if(!i){r.getContent=function(){var E=sap.ui.getCore().byId(this.__myParentElementId);if(E){var p=[];var s=E.getLabelControl();var t=E.getFields();if(!s||t.length<=1){p=t;if(s){p.unshift(s);}}else{var L=this.__myParentLayout;var u=this.__myParentContainerId;var v=E.getId();if(s){p.push(s);}if(L.mContainers[u]&&L.mContainers[u][2]&&L.mContainers[u][2][v]&&L.mContainers[u][2][v][1]){p.push(L.mContainers[u][2][v][1]);}}return p;}else{return false;}};}else{r.getContent=function(){var E=sap.ui.getCore().byId(this.__myParentElementId);if(E){return E.getFields();}else{return false;}};}}else if(C){r._getAccessibleRole=function(){var C=sap.ui.getCore().byId(this.__myParentContainerId);if(!C.getTitle()&&!C.getExpandable()){return"form";}};}if((E&&!i)||(!E&&!C.getTitle()&&!C.getExpandable())){g(r,false);}else{r.setLayoutData(new a({margin:false}));}return r;}function g(r,O){if(O){if(r.__originalGetLayoutData){r.getLayoutData=r.__originalGetLayoutData;delete r.__originalGetLayoutData;}}else if(!r.__originalGetLayoutData){r.__originalGetLayoutData=r.getLayoutData;r.getLayoutData=function(){var L=this.__myParentLayout;var C=sap.ui.getCore().byId(this.__myParentContainerId);var E=sap.ui.getCore().byId(this.__myParentElementId);var i;if(E){i=L.getLayoutDataForElement(E,"sap.ui.layout.ResponsiveFlowLayoutData");}else if(C){i=L.getLayoutDataForElement(C,"sap.ui.layout.ResponsiveFlowLayoutData");}if(i){return i;}else{return L._defaultLayoutData;}};}}function h(L,r,p){var s;var w=0;for(var i=0;i<p.length;i++){var t=p[i];s=L.getLayoutDataForElement(t,"sap.ui.layout.ResponsiveFlowLayoutData");if(s){w=w+s.getWeight();}else{w++;}}s=r.getLayoutData();if(s){s.setWeight(w);}else{r.setLayoutData(new a({weight:w}));}}function j(r){if(r.__myParentContainerId){r.__myParentContainerId=undefined;}if(r.__myParentElementId){r.__myParentElementId=undefined;}r.__myParentLayout=undefined;r.destroy();}function k(L,C){var i=L.mContainers[C];var r;var E=i[2];if(E){for(var s in E){if(E[s][1]){j(E[s][1]);}r=E[s][0];j(r);delete E[s];}}r=i[1];if(r){r.removeAllContent();j(r);}var p=i[0];if(p){d(p);}delete L.mContainers[C];}function m(L,C,E,r,i,I){var s=E.getId();var p=s+"--RFLayout";var t=sap.ui.getCore().byId(p);if(!r[s]&&t){var O=t.__myParentContainerId;r[s]=L.mContainers[O][2][s];i.insertContent(t,I);t.__myParentContainerId=C.getId();if(r[s][1]){r[s][1].__myParentContainerId=C.getId();}delete L.mContainers[O][2][s];}}function n(L,p){var C=p.getFormContainers();var r;var s=0;var t=0;var i=0;for(i=0;i<C.length;i++){r=C[i];if(r.getVisible()){s++;}}if(s>1){if(!L._mainRFLayout){L._mainRFLayout=new R(p.getId()+"--RFLayout").setParent(L);}else{var u=L._mainRFLayout.getContent();t=u.length;var E=false;for(i=0;i<t;i++){var v=u[i];r=undefined;if(v.getContainer){r=sap.ui.getCore().byId(v.getContainer());}else{r=sap.ui.getCore().byId(v.__myParentContainerId);}if(r&&r.getVisible()){var w=L.mContainers[r.getId()];if(w[0]&&w[0]!=v){E=true;break;}if(!w[0]&&w[1]&&w[1]!=v){E=true;break;}}else{L._mainRFLayout.removeContent(v);}}if(E){L._mainRFLayout.removeAllContent();t=0;}}if(t<s){for(i=0;i<C.length;i++){r=C[i];if(r.getVisible()){var x=r.getId();if(L.mContainers[x]){if(L.mContainers[x][0]){L._mainRFLayout.addContent(L.mContainers[x][0]);}else if(L.mContainers[x][1]){L._mainRFLayout.addContent(L.mContainers[x][1]);}}}}}}}function o(O){var L=0;if(!Object.keys){q.each(O,function(){L++;});}else{L=Object.keys(O).length;}return L;}}());return b;},true);
